import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Item, ItemParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询项目类型
 */
export async function pageItem(params: ItemParam) {
  const res = await request.get<ApiResult<PageResult<Item>>>(
    MODULES_API_URL + '/booking/item/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询项目类型列表
 */
export async function listItem(params?: ItemParam) {
  const res = await request.get<ApiResult<Item[]>>(
    MODULES_API_URL + '/booking/item',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加项目类型
 */
export async function addItem(data: Item) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/item',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改项目类型
 */
export async function updateItem(data: Item) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/item',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除项目类型
 */
export async function removeItem(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/item/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除项目类型
 */
export async function removeBatchItem(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/item/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询项目类型
 */
export async function getItem(id: number) {
  const res = await request.get<ApiResult<Item>>(
    MODULES_API_URL + '/booking/item/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
